CSE5WDC Assignment 1 Plagiarism This is assignment must be completed individually, not in groups. You are welcome to discuss problems with fellow students, but the work that you submit must be your...

1 answer below »
Web development on the cloud


CSE5WDC Assignment 1 Plagiarism This is assignment must be completed individually, not in groups. You are welcome to discuss problems with fellow students, but the work that you submit must be your own. Don't try to plagiarise, it's extremely obvious and will only serve to get you into trouble. That's not any fun for you or for us. Due Date This assignment is due on Monday, 14 September 2020, 5:00 PM. Penalties are applied to late assignments (accepted up to 5 days after the due date only). See the departmental Student Handbook for details. Submission Details · Zip up everything in your project directory as well as word document or PDF of current document in which the required boxes (code and screenshots) have been filled in. · Submit your zipped file via LMS Your Student ID: 20454453 Your Full Name: Rahul Sandeepa Task 1 (5 marks) – Create a folder called lab04-react-task-list and use git command to clone (from https://[email protected]/abken/lab04-react-task-list.git) lab04-react-task-list project files to this folder. Write down the required command in the below box. > Task 2 (10 marks) – Create the Docker image (as instructed in lab 4 document) to run lab04-react-task-list web app. Once you could browse the web app via http://localhost:3000, you need to push the project folder to your remote repository. Create a public remote repository named “Assignment01-WDC”. List all the required git command to push all the files into this repo. > Hint: you might need to run the following git commands before push command: git add . git commit -m "initial commit" · (Windows Users: If you get ./start.sh: not found error message after running the container, you could fix it by converting start.sh from Windows-style to UNIX-style line endings. To do that: Open start.sh using notepad++, from Edit menu -> EOL conversion -> Unix (FL) and save the file.) · If you are not able to use docker container in your machine, setup your own development environment using the provide instruction: https://lms.latrobe.edu.au/mod/forum/discuss.php?d=1046064 Type in your remote repository URL in the below box: https:// After pushing project folders to your remote repository, make a screenshot from your Bitbucket repository dashboard so that the list of files/folders are visible. From this stage, after every change (modify, delete, add) of the source code, you must commit your code to the repository with a proper description (For example if Task 5 is asking to add a button to do change the content of an HTML element, you should git commit –m “Task 1 – adding change btn”). Feel free to use any git tools such as source tree. But your remote repo should reflect all your commits. Task 3 (5 marks) - Modify the config file so that the web app runs on http://localhost:4548 Type in the required changes: Modified File Name/s: Modified Line/s: (please note that you need to commit the changes into your remote repository with a description) Also, you need to make a screenshot from your web browser which shows the web app is running on port 4548. Task 4 (20 marks) - Create a folder in the project folder and name it public. Add index.html file and styles.css to this folder. index.html should shows a simple “Hello World” text with the following style: Font-family: Arial, Font Size: 18 Font weight: bold Font Color: Blue (Style of the Hello World message should be defined in styles.css. refer to the lab01-simple-webpage) Type in the required codes in index.html Type in the required codes in styles.css Next you need to redirect the web app to the index.html. For example when you browse http://localhost:4548, instead of TaskList page from the lab 04, it should shows your index.html file. Hint: look at app.use() and res.redirect() methods of Express API. Type in the required changes: Modified File Name: Modified Line/s: Then, open http://localhost:4548 and take a screenshot from your browser. Your screenshot should shows the browser URL address and the content of index.html. Task 5 (15 marks) – Write a java script function which gets array of objects (see the bellow) as input and returns an array with the following elements: Name, email, state For example, if you call that function it should return: [{John,'[email protected]',WX},{amin,'[email protected]',VIC},{Linda,'[email protected]',QLD} ] const users = [ { uid: 001, email: '[email protected]', personalInfo: { name: 'John', address: { line1: 'westwish st', line2: 'washmasher', city: 'wallas', state: 'WX' } } }, { uid: 063, email: '[email protected]', personalInfo: { name: 'amin', address: { line1: 'Heidelberg', line2: '', city: 'Melbourne', state: 'VIC' } } }, { uid: 045, email: '[email protected]', personalInfo: { name: 'Linda', address: { line1: 'Cherry st', line2: 'Kangaroo Point', city: 'Brisbane', state: 'QLD' } } } ] Type in the function implementation: function returnUsers(users) { …. return … ; } execute returnUsers function in your browser developer tools and take a screenshot of the result: Task 6 (20 marks): add a HTML button (lets call this button ‘Show Users’) to invoke the written JS function of task 5, and display the output of function in a HTML table. Type in the required codes in index.html (Push your code to the remote repo using a proper label). Take a screenshot of result (list of users in html table) Task 7 (25 marks): Create a new repository branch and name it “Development”. Add another button (let’s call it Sort) to sort the result of returnUsers() function by name and replace the table contents by sorted version. push your code to the “Development” branch. After finishing your implementation merge your code with the master branch (You can use the Lodash library to sort the list). Type in the required codes in index.html: Type in the git commands for creating a new branch, switching to it and finally merging with the master branch · Take a screenshot of result (showing the list after clocking sort button) Task 8 (Bonus – 5 marks): Rebuild the docker image and push it to the hub.ducker.com so that it can be downloaded via: · docker pull Assignment01-WDC PowerPoint Presentation CSE2WDC/CSE5WDC: Web Development on the Cloud Lecturer: Amin Abken Lecture 2 Semester 2- 2020 Virtual Machines What are Virtual Machines? What are virtual machines? ● At the base is the host, underlying hardware ● Virtual machine manager (VMM) ● Also known as the hypervisor ● Creates and runs virtual machines ● Provides an interface that is identical to the host (except in the case of paravirtualization) ● Usually guest is an operating system ● Configure resources available to each guest operating system E.g. two virtual CPUs, 4GB of RAM, 10GB of disk, etc. Why Virtual Machines are Useful on the Cloud? ● Protection due to isolation ● Host systems is protected against virus, security breaches and bugs in guest operating system applications ● One guest operating system is protected from another guest operating system ● E.g. Two guest operating systems can run on the same hardware yet not be able to read information from the each other. Thereby achieving security. ● Flexibility ● Suspend and resume virtual machine ● Snapshot of virtual machine state ● Can be used to allow restoring to previous state ● Allow virtual machine to be cloned. Why Virtual Machines are Useful on the Cloud? ● Consolidation of resources ● Many lightly used systems can be combined to create one more heavily used system ● Cheaper to manage ● E.g. 100 physical servers running 20 virtual servers equals 2000 virtual servers. ● Many people needed to administer 2000 real servers but one or two can manage 2000 virtual servers ● A useful tool is templating ● One standard virtual machine image is used for multiple virtual machines Why Virtual Machines are Useful on the Cloud? ● Live migration ● Moves a running guest from one physical machine to another. ● Useful when system is overloaded for load balancing ● Useful when hardware is to be upgraded or repaired ● Install all software and configuration settings on a virtual machine image. ● Makes redeployment of operating system and environment much faster. More Detail on Virtual Machines ● If you want to learn more about virtual machines take the operating systems and computer architecture class ● CSE3OSA Containers Containers ● Containers are lighter weight than virtual machines since they do not involve running an extra layer of operating systems (guest OS) ● Also containers do not need to run an expensive hypervisor. ● In this subject we will use the container manager called Docker. ● Currently docker is by far the most popular container manager in the world. Containers Containers ● Virtual machines are great but they are heavy weight (high overhead) ● They require a hypervisor layer ● In contrast a container is like a light weight virtual machine which uses the host operating system by using
Answered Same DaySep 09, 2021CSE5WDCLa Trobe University

Answer To: CSE5WDC Assignment 1 Plagiarism This is assignment must be completed individually, not in groups....

Lakshmi answered on Sep 16 2021
132 Votes
lab04-react-task-list/lab04-react-task-list/.babelrc
{
"presets": ["es2015", "react"]
}
lab04-react-task-list/lab04-react-task-list/.git/.COMMIT_EDITMSG.swp
lab04-react-task-list/lab04-react-task-list/.git/COMMIT_EDITMSG
Task 7 - Add new button sort and onclick show sorted table by name.
lab04-react-task-list/lab04-react-task-list/.git/config
[core]
    repositoryformatversion = 0
    filemode = true
    bare = false
    logallrefupdates = true
    ignorecase = true
    precomposeunicode = true
[remote "origin"]
    url = https://github.com/HarishJella/20454453Assignment01-WDC.git
    fetch = +refs/heads/*:refs/remotes/origin/*
lab04-react-task-list/lab04-react-task-list/.git/description
Unnamed repository; edit this file 'description' to name the repository.
lab04-react-task-list/lab04-react-task-list/.git/FETCH_HEAD
838c79098c79e3d6bb68da6c9e94cb38b0797923    not-for-merge    branch 'Development' of https://github.com/HarishJella/20454453Assignment01-WDC
b7667203d9edbf2a4ffdd047d138700cd07d3a24    not-for-merge    branch 'master' of https://github.com/HarishJella/20454453Assignment01-WDC
lab04-react-task-list/lab04-react-task-list/.git/HEAD
ref: refs/heads/master
lab04-react-task-list/lab04-react-task-list/.git/hooks/applypatch-msg.sample
#!/bin/sh
#
# An example hook script to check the commit log message taken by
# applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit. The hook is
# allowed to edit the commit message file.
#
# To enable this hook, rename this file to "applypatch-msg".
. git-sh-setup
commitmsg="$(git rev-parse --git-path hooks/commit-msg)"
test -x "$commitmsg" && exec "$commitmsg" ${1+"$@
"}
:
lab04-react-task-list/lab04-react-task-list/.git/hooks/commit-msg.sample
#!/bin/sh
#
# An example hook script to check the commit log message.
# Called by "git commit" with one argument, the name of the file
# that has the commit message. The hook should exit with non-zero
# status after issuing an appropriate message if it wants to stop the
# commit. The hook is allowed to edit the commit message file.
#
# To enable this hook, rename this file to "commit-msg".
# Uncomment the below to add a Signed-off-by line to the message.
# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
# hook is more suited to it.
#
# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
# This example catches duplicate Signed-off-by lines.
test "" = "$(grep '^Signed-off-by: ' "$1" |
     sort | uniq -c | sed -e '/^[     ]*1[     ]/d')" || {
    echo >&2 Duplicate Signed-off-by lines.
    exit 1
}
lab04-react-task-list/lab04-react-task-list/.git/hooks/fsmonitor-watchman.sample
#!/usr/bin/perl
use strict;
use warnings;
use IPC::Open2;
# An example hook script to integrate Watchman
# (https://facebook.github.io/watchman/) with git to speed up detecting
# new and modified files.
#
# The hook is passed a version (currently 1) and a time in nanoseconds
# formatted as a string and outputs to stdout all files that have been
# modified since the given time. Paths must be relative to the root of
# the working tree and separated by a single NUL.
#
# To enable this hook, rename this file to "query-watchman" and set
# 'git config core.fsmonitor .git/hooks/query-watchman'
#
my ($version, $time) = @ARGV;
# Check the hook interface version
if ($version == 1) {
    # convert nanoseconds to seconds
    $time = int $time / 1000000000;
} else {
    die "Unsupported query-fsmonitor hook version '$version'.\n" .
     "Falling back to scanning...\n";
}
my $git_work_tree;
if ($^O =~ 'msys' || $^O =~ 'cygwin') {
    $git_work_tree = Win32::GetCwd();
    $git_work_tree =~ tr/\\/\//;
} else {
    require Cwd;
    $git_work_tree = Cwd::cwd();
}
my $retry = 1;
launch_watchman();
sub launch_watchman {
    my $pid = open2(\*CHLD_OUT, \*CHLD_IN, 'watchman -j --no-pretty')
     or die "open2() failed: $!\n" .
     "Falling back to scanning...\n";
    # In the query expression below we're asking for names of files that
    # changed since $time but were not transient (ie created after
    # $time but no longer exist).
    #
    # To accomplish this, we're using the "since" generator to use the
    # recency index to select candidate nodes and "fields" to limit the
    # output to file names only. Then we're using the "expression" term to
    # further constrain the results.
    #
    # The category of transient files that we want to ignore will have a
    # creation clock (cclock) newer than $time_t value and will also not
    # currently exist.
    my $query = <<"    END";
        ["query", "$git_work_tree", {
            "since": $time,
            "fields": ["name"],
            "expression": ["not", ["allof", ["since", $time, "cclock"], ["not", "exists"]]]
        }]
    END
    print CHLD_IN $query;
    close CHLD_IN;
    my $response = do {local $/; };
    die "Watchman: command returned no output.\n" .
     "Falling back to scanning...\n" if $response eq "";
    die "Watchman: command returned invalid output: $response\n" .
     "Falling back to scanning...\n" unless $response =~ /^\{/;
    my $json_pkg;
    eval {
        require JSON::XS;
        $json_pkg = "JSON::XS";
        1;
    } or do {
        require JSON::PP;
        $json_pkg = "JSON::PP";
    };
    my $o = $json_pkg->new->utf8->decode($response);
    if ($retry > 0 and $o->{error} and $o->{error} =~ m/unable to resolve root .* directory (.*) is not watched/) {
        print STDERR "Adding '$git_work_tree' to watchman's watch list.\n";
        $retry--;
        qx/watchman watch "$git_work_tree"/;
        die "Failed to make watchman watch '$git_work_tree'.\n" .
         "Falling back to scanning...\n" if $? != 0;
        # Watchman will always return all files on the first query so
        # return the fast "everything is dirty" flag to git and do the
        # Watchman query just to get it over with now so we won't pay
        # the cost in git to look up each individual file.
        print "/\0";
        eval { launch_watchman() };
        exit 0;
    }
    die "Watchman: $o->{error}.\n" .
     "Falling back to scanning...\n" if $o->{error};
    binmode STDOUT, ":utf8";
    local $, = "\0";
    print @{$o->{files}};
}
lab04-react-task-list/lab04-react-task-list/.git/hooks/post-update.sample
#!/bin/sh
#
# An example hook script to prepare a packed repository for use over
# dumb transports.
#
# To enable this hook, rename this file to "post-update".
exec git update-server-info
lab04-react-task-list/lab04-react-task-list/.git/hooks/pre-applypatch.sample
#!/bin/sh
#
# An example hook script to verify what is about to be committed
# by applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-applypatch".
. git-sh-setup
precommit="$(git rev-parse --git-path hooks/pre-commit)"
test -x "$precommit" && exec "$precommit" ${1+"$@"}
:
lab04-react-task-list/lab04-react-task-list/.git/hooks/pre-commit.sample
#!/bin/sh
#
# An example hook script to verify what is about to be committed.
# Called by "git commit" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message if
# it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-commit".
if git rev-parse --verify HEAD >/dev/null 2>&1
then
    against=HEAD
else
    # Initial commit: diff against an empty tree object
    against=$(git hash-object -t tree /dev/null)
fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)
# Redirect output to stderr.
exec 1>&2
# Cross platform projects tend to avoid non-ASCII filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
    # Note that the use of brackets around a tr range is ok here, (it's
    # even required, for portability to Solaris 10's /usr/bin/tr), since
    # the square bracket bytes happen to fall in the designated range.
    test $(git diff --cached --name-only --diff-filter=A -z $against |
     LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then
    cat <<\EOF
Error: Attempt to add a non-ASCII file name.
This can cause problems if you want to work with people on other platforms.
To be portable it is advisable to rename the file.
If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
    exit 1
fi
# If there are whitespace errors, print the offending file names and fail.
exec git diff-index --check --cached $against --
lab04-react-task-list/lab04-react-task-list/.git/hooks/pre-merge-commit.sample
#!/bin/sh
#
# An example hook script to verify what is about to be committed.
# Called by "git merge" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message to
# stderr if it wants to stop the merge commit.
#
# To enable this hook, rename this file to "pre-merge-commit".
. git-sh-setup
test -x "$GIT_DIR/hooks/pre-commit" &&
exec "$GIT_DIR/hooks/pre-commit"
:
lab04-react-task-list/lab04-react-task-list/.git/hooks/prepare-commit-msg.sample
#!/bin/sh
#
# An example hook script to prepare the commit log message.
# Called by "git commit" with the name of the file that has the
# commit message, followed by the description of the commit
# message's source. The hook's purpose is to edit the commit
# message file. If the hook fails with a non-zero status,
# the commit is aborted.
#
# To enable this hook, rename this file to "prepare-commit-msg".
# This hook includes three examples. The first one removes the
# "# Please enter the commit message..." help message.
#
# The second includes the output of "git diff --name-status -r"
# into the message, just before the "git status" output. It is
# commented because it doesn't cope with --amend or with squashed
# commits.
#
# The third example adds a Signed-off-by line to the message, that can
# still be edited. This is rarely a good idea.
COMMIT_MSG_FILE=$1
COMMIT_SOURCE=$2
SHA1=$3
/usr/bin/perl -i.bak -ne 'print unless(m/^. Please enter the commit message/..m/^#$/)' "$COMMIT_MSG_FILE"
# case "$COMMIT_SOURCE,$SHA1" in
# ,|template,)
# /usr/bin/perl -i.bak -pe '
# print "\n" . `git diff --cached --name-status -r`
#      if /^#/ && $first++ == 0' "$COMMIT_MSG_FILE" ;;
# *) ;;
# esac
# SOB=$(git var GIT_COMMITTER_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# git interpret-trailers --in-place --trailer "$SOB" "$COMMIT_MSG_FILE"
# if test -z "$COMMIT_SOURCE"
# then
# /usr/bin/perl -i.bak -pe 'print "\n" if !$first_line++' "$COMMIT_MSG_FILE"
# fi
lab04-react-task-list/lab04-react-task-list/.git/hooks/pre-push.sample
#!/bin/sh
# An example hook script to verify what is about to be pushed. Called by "git
# push" after it has checked the remote status, but before anything has been
# pushed. If this script exits with a non-zero status nothing will be pushed.
#
# This hook is called with the following parameters:
#
# $1 -- Name of the remote to which the push is being done
# $2 -- URL to which the push is being done
#
# If pushing without using a named remote those arguments will be equal.
#
# Information about the commits which are being pushed is supplied as lines to
# the standard input in the form:
#
#
#
# This sample shows how to prevent push of commits where the log message starts
# with "WIP" (work in progress).
remote="$1"
url="$2"
z40=0000000000000000000000000000000000000000
while read local_ref local_sha remote_ref remote_sha
do
    if [ "$local_sha" = $z40 ]
    then
        # Handle delete
        :
    else
        if [ "$remote_sha" = $z40 ]
        then
            # New branch, examine all commits
            range="$local_sha"
        else
            # Update to existing branch, examine new commits
            range="$remote_sha..$local_sha"
        fi
        # Check for WIP commit
        commit=`git rev-list -n 1 --grep '^WIP' "$range"`
        if [ -n "$commit" ]
        then
            echo >&2 "Found WIP commit in $local_ref, not pushing"
            exit 1
        fi
    fi
done
exit 0
lab04-react-task-list/lab04-react-task-list/.git/hooks/pre-rebase.sample
#!/bin/sh
#
# Copyright (c) 2006, 2008 Junio C Hamano
#
# The "pre-rebase" hook is run just before "git rebase" starts doing
# its job, and can prevent the command from running by exiting with
# non-zero status.
#
# The hook is called with the following parameters:
#
# $1 -- the upstream the series was forked from.
# $2 -- the branch being rebased (or empty when rebasing the current branch).
#
# This sample shows how to prevent topic branches that are already
# merged to 'next' branch from getting rebased, because allowing it
# would result in rebasing already published history.
publish=next
basebranch="$1"
if test "$#" = 2
then
    topic="refs/heads/$2"
else
    topic=`git symbolic-ref HEAD` ||
    exit 0 ;# we do not interrupt rebasing detached HEAD
fi
case "$topic" in
refs/heads/??/*)
    ;;
*)
    exit 0 ;# we do not interrupt others.
    ;;
esac
# Now we are dealing with a topic branch being rebased
# on top of master. Is it OK to rebase it?
# Does the topic really exist?
git show-ref -q "$topic" || {
    echo >&2 "No such branch $topic"
    exit 1
}
# Is topic fully merged to master?
not_in_master=`git rev-list --pretty=oneline ^master "$topic"`
if test -z "$not_in_master"
then
    echo >&2 "$topic is fully merged to master; better remove it."
    exit 1 ;# we could allow it, but there is no point.
fi
# Is topic ever merged to next? If so you should not be rebasing it.
only_next_1=`git rev-list ^master "^$topic" ${publish} | sort`
only_next_2=`git rev-list ^master ${publish} | sort`
if test "$only_next_1" = "$only_next_2"
then
    not_in_topic=`git rev-list "^$topic" master`
    if test -z "$not_in_topic"
    then
        echo >&2 "$topic is already up to date with master"
        exit 1 ;# we could allow it, but there is no point.
    else
        exit 0
    fi
else
    not_in_next=`git rev-list --pretty=oneline ^${publish} "$topic"`
    /usr/bin/perl -e '
        my $topic = $ARGV[0];
        my $msg = "* $topic has commits already merged to public branch:\n";
        my (%not_in_next) = map {
            /^([0-9a-f]+) /;
            ($1 => 1);
        } split(/\n/, $ARGV[1]);
        for my $elem (map {
                /^([0-9a-f]+) (.*)$/;
                [$1 => $2];
            } split(/\n/, $ARGV[2])) {
            if (!exists $not_in_next{$elem->[0]}) {
                if ($msg) {
                    print STDERR $msg;
                    undef $msg;
                }
                print STDERR " $elem->[1]\n";
            }
        }
    ' "$topic" "$not_in_next" "$not_in_master"
    exit 1
fi
<<\DOC_END
This sample hook safeguards topic branches that have been
published from being rewound.
The workflow assumed here is:
* Once a topic branch forks from "master", "master" is never
merged into it again (either directly or indirectly).
* Once a topic branch is fully cooked and merged into "master",
it is deleted. If you need to build on top of it to correct
earlier mistakes, a new topic branch is created by forking at
the tip of the "master". This is not strictly necessary, but
it makes it easier to keep your history simple.
* Whenever you need to test or publish your changes to topic
branches, merge them into "next" branch.
The script, being an example, hardcodes the publish branch name
to be "next", but it is trivial to make it configurable via
$GIT_DIR/config mechanism.
With this workflow, you would want to know:
(1) ... if a topic branch has ever been merged to "next". Young
topic branches can have stupid mistakes you would rather
clean up before publishing, and things that have not been
merged into other branches can be easily rebased without
affecting other people. But once it is published, you would
not want to rewind it.
(2) ... if a topic branch has been fully merged to "master".
Then you can delete it. More importantly, you should not
build on top of it -- other people may already want to
change things related to the topic as patches against your
"master", so if you need further changes, it is better to
fork the topic (perhaps with the same name) afresh from the
tip of "master".
Let's look at this example:
         o---o---o---o---o---o---o---o---o---o "next"
         / / / /
         / a---a---b A / /
        / / / /
     / / c---c---c---c B /
     / / / \ /
     / / / b---b C \ /
     / / / / \ /
---o---o---o---o---o---o---o---o---o---o---o "master"
A, B and C are topic branches.
* A has one fix since it was merged up to "next".
* B has finished. It has been fully merged up to "master" and "next",
and is ready to be deleted.
* C has not merged to "next" at all.
We would want to allow C to be rebased, refuse A, and encourage
B to be deleted.
To compute (1):
    git rev-list ^master ^topic next
    git rev-list ^master next
    if these match, topic has not merged in next at all.
To compute (2):
    git rev-list master..topic
    if this is empty, it is fully merged to...
SOLUTION.PDF

Answer To This Question Is Available To Download

Related Questions & Answers

More Questions »

Submit New Assignment

Copy and Paste Your Assignment Here